#include "DS_lib.h"

//   DISPLAY START
void ds_wdr (byte i)
{
 byte out1,out2;
 DISPLAY_DSPLE=1;
 DISPLAY_DSPLRW=0;
 DISPLAY_DSPLRS=1;
 out1 = i;
 out1 = (out1>>4);
 out2 = DISPLAY_PORT;
 out2 = out2 AND 0xf0;
 out2 = out2 OR out1;
 DISPLAY_PORT=out2;
 DISPLAY_DSPLE=0;
 Delay_us(10);
 DISPLAY_DSPLE=1;
 out1 = i AND 0x0f;
 out2 = DISPLAY_PORT;
 out2 = out2 AND 0xf0;
 out2 = out2 OR out1;
 DISPLAY_PORT=out2;
 DISPLAY_DSPLE=0;
 Delay_ms(1);
} 



void ds_wir (byte i) reentrant
{
 byte out1,out2;
 DISPLAY_DSPLE=1;
 DISPLAY_DSPLRW=0;
 DISPLAY_DSPLRS=0;
 out1 = i;
 out1 = (out1>>4);
 out2 = DISPLAY_PORT;
 out2 = out2 AND 0xf0;
 out2 = out2 OR out1;
 DISPLAY_PORT=out2;
 DISPLAY_DSPLE=0;
 Delay_us(10);
 DISPLAY_DSPLE=1;
 out1 = i AND 0x0f;
 out2 = DISPLAY_PORT;
 out2 = out2 AND 0xf0;
 out2 = out2 OR out1;
 DISPLAY_PORT=out2;
 DISPLAY_DSPLE=0;
 Delay_ms(2);
} 

void ds_wirx (byte i)
{
 byte out1,out2;
 DISPLAY_DSPLE=1;
 DISPLAY_DSPLRW=0;
 DISPLAY_DSPLRS=0;
 out1 = (i>>4);
 out2 = DISPLAY_PORT;
 out2 = out2 AND 0xf0;
 out2 = out2 OR out1;
 DISPLAY_PORT=out2;
 DISPLAY_DSPLE=0;
 Delay_ms(20); 
} 

void DS_Putc (byte pos,byte ch) reentrant
{
 byte out1,out2;
 ds_wir(pos OR 0x80);
 DISPLAY_DSPLE=1;
 DISPLAY_DSPLRW=0;
 DISPLAY_DSPLRS=1;
 out1 = ch;
 out1 = (out1>>4);
 out2 = DISPLAY_PORT;
 out2 = out2 AND 0xf0;
 out2 = out2 OR out1;
 DISPLAY_PORT=out2;
 DISPLAY_DSPLE=0;
 Delay_us(10);
 DISPLAY_DSPLE=1;
 out1 = ch AND 0x0f;
 out2 = DISPLAY_PORT;
 out2 = out2 AND 0xf0;
 out2 = out2 OR out1;
 DISPLAY_PORT=out2;
 DISPLAY_DSPLE=0;
 Delay_us(200);
} 


void DS_Init (void)
{
 byte i; 
   DISPLAY_DSPLE=0;
   DISPLAY_DSPLRS=0; 
   Delay_ms(200);
   ds_wirx(0x30);
   ds_wirx(0x30);  
   ds_wirx(0x30);
   ds_wirx(0x20);

   ds_wir(0x28);
   ds_wir(0x0c);
   ds_wir(0x01);
   ds_wir(0x06);
   DS_Print(0,"INIT OK.");
}

void DS_Print(byte pos,char * c)
{   
   byte i;
   for (i=0;(c[i]!='\0');)
    {
      DS_Putc(pos,c[i]);
      Delay_ms(1);  
      pos++;
      i++;
    }  
}  


void DS_con(void)
{
  ds_wir(0x0f);
}  

void DS_con1(void) // specialny kurzor
{
  ds_wir(0x0d);   // blika iba znak - ciarka - kurzor - chyba
}  


void DS_coff(void)
{
  ds_wir(0x0c);
}  

void DS_scur(byte pos)
{
  ds_wir(pos | 0x80);
}  

//   DISPLAY END

 // END